E. Negatives and Positives

time limit per test

2 seconds

memory limit per test

256 megabytes

Given an array aa consisting of nn elements, find the maximum possible sum the array can have after performing the following operation any number of times:

  • Choose 22 adjacent elements and flip both of their signs. In other words choose an index ii such that 1≤i≤n−11≤i≤n−1 and assign ai=−aiai=−ai and ai+1=−ai+1ai+1=−ai+1.

Input

The input consists of multiple test cases. The first line contains an integer tt (1≤t≤10001≤t≤1000) --- the number of test cases. The descriptions of the test cases follow.

The first line of each test case contains an integer nn (2≤n≤2⋅1052≤n≤2⋅105) --- the length of the array.

The following line contains nn space-separated integers a1,a2,...,ana1,a2,...,an (−109≤ai≤109−109≤ai≤109).

It is guaranteed that the sum of nn over all test cases does not exceed 2⋅1052⋅105.

Output

For each test case, output the maximum possible sum the array can have after performing the described operation any number of times.

Example

Input

Copy

复制代码

5

3

-1 -1 -1

5

1 5 -5 0 2

3

1 2 3

6

-1 10 9 8 7 6

2

-1 -1

Output

Copy

复制代码
1
13
6
39
2

Note

For the first test case, by performing the operation on the first two elements, we can change the array from [−1,−1,−1][−1,−1,−1] to [1,1,−1][1,1,−1], and it can be proven this array obtains the maximum possible sum which is 1+1+(−1)=11+1+(−1)=1.

For the second test case, by performing the operation on −5−5 and 00, we change the array from [1,5,−5,0,2][1,5,−5,0,2] to [1,5,−(−5),−0,2]=[1,5,5,0,2][1,5,−(−5),−0,2]=[1,5,5,0,2], which has the maximum sum since all elements are non-negative. So, the answer is 1+5+5+0+2=131+5+5+0+2=13.

For the third test case, the array already contains only positive numbers, so performing operations is unnecessary. The answer is just the sum of the whole array, which is 1+2+3=61+2+3=6.

解题说明:此题是一道数学题,找规律能发现可以采用贪心算法,不管执行了多少次的操作,数组中负数个数的奇偶性总是保持不变。因此如果一开始数组中有偶数个负数,那么我们总是可以通过若干次的操作使得负数的个数变成0,因此答案就是所有数的绝对值之和。如果一开始数组中有奇数个负数,那么最终至少要有一个负数,所有可以让数组中绝对值最小的那个数为负数(,那么答案就是其他数的绝对值之和再减去这个最小数的绝对值。

cpp 复制代码
#include <bits/stdc++.h>
#include<iostream>
#include<cstdio>
#include<cmath>
#include<algorithm>
using namespace std;

typedef long long LL;


int main()
{
	int t;
	int n;
	scanf("%d", &t);
	while (t--)
	{
		scanf("%d", &n);
		int cnt = 0, minv = 2e9;
		LL s = 0;
		while (n--)
		{
			int x;
			scanf("%d", &x);
			if (x < 0)
			{
				cnt++;
				x *= -1;
			}
			s += x;
			minv = min(minv, x);
		}
		if (cnt & 1)
		{
			s -= 2 * minv;
		}
		printf("%lld\n", s);
	}
	return 0;
}
相关推荐
ac-er888826 分钟前
PHP 二分法查找算法
开发语言·算法·php
Choshim-35 分钟前
7-9 求无向图连通分量的数量
数据结构·算法·深度优先
Eric.Lee202142 分钟前
数据集-目标检测系列- 昙花(昙花一现) 检测数据集 epiphyllum >> DataBall
算法·yolo·目标检测·计算机视觉·昙花一现·昙花检测
淀粉肠kk2 小时前
【数据结构】二叉树(2)
数据结构·算法
总是学不会.2 小时前
【贪心算法】绿洲之旅:最少次数补给探索
java·算法·intellij-idea
超甜的布丁mm2 小时前
【图像检测】深度学习与传统算法的区别(识别逻辑、学习能力、泛化能力)
图像处理·人工智能·python·深度学习·算法·视觉检测·卷积神经网络
予安灵2 小时前
图的邻接矩阵和邻接表存储
数据结构·算法·
南宫生2 小时前
力扣-位运算-1【算法学习day.41】
java·学习·算法·leetcode
Beau_Will3 小时前
数据结构-树状数组专题(2)
数据结构·c++·算法